#include <avr/io.h>
#include <util/delay.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include "lcd-routines.h"

#define keyb_port PORTC
#define eingang 0x00
#define ausgang 0xFF

unsigned char g_schritte[10];
unsigned char k_schritte[10];
int k_zeiger;
int g_zeiger;
char spannung[10];
char istwert[10];
int sollwert;
int temp;
unsigned char a;

//########################
int ports_init(void){

	DDRA = 0xFC;
	DDRB = ausgang;
	DDRC = ausgang;
	DDRD = 0xC0;

return 0;
}
//########################

//########################
int adc_init(void){

ADCSRA = 0xEE;					// ADC einschalten, Free-Running--Mode,
						// prescaler = 64 -> 125 kHz
return 0;
}

//########################

int main(void){
	
	_delay_ms(50);

	MCUCSR |= (1<<JTD);
	MCUCSR |= (1<<JTD);

	ports_init();
	lcd_init();
	adc_init();
	ausgabe_konstanten_init();


while(1){

	strom_messen();
	spannung_messen();
	lcd_test();
	}

return 0;
}
//########################


//########################
int strom_messen(void){

istwert == 0;
ADMUX &= ~(1<<MUX0);	//Kanal 0

while ( !(ADCSRA & (1 << ADIF)) ) {
;			//auf Abschluss der Konvertierung warten
}

temp = ADCW;			//Dummy-Readout
temp = 0;				//Mllwert lschen

for(a=0; a <= 15; a++){
	
	while ( !(ADCSRA & (1 << ADIF)) ) {
   	 ; //auf Abschluss der Konvertierung warten
	}

	temp += ADCW;
	}

	temp /= 16;


	itoa(temp, istwert, 10);
return 0;
}
//########################


//########################
int spannung_messen(void){

spannung == 0;
ADMUX |= (1<<MUX0);		//Kanal1

while ( !(ADCSRA & (1 << ADIF)) ) {
; 			//auf Abschluss der Konvertierung warten
}

temp = ADCW;			//Dummy-Readout
temp = 0;			//Mllwert lschen


for(a=0; a <= 15; a++){

	while ( !(ADCSRA & (1 << ADIF)) ) {
   	 ;//auf Abschluss der Konvertierung warten
	}
	
	temp += ADCW;
	}

	temp /= 16;


	itoa(temp, spannung, 10);
return 0;
}
//########################

//########################
int lcd_test(){

	set_cursor(0,1);
		lcd_string("Messwert 1 = ");
		lcd_string(istwert);

	set_cursor(0,2);
		lcd_string("Messwert 2 = ");
		lcd_string(spannung);

	set_cursor(0,3);
		lcd_string("Ich bin ");
		lcd_data(0xE4);
		lcd_string("-de... zzZZ");


return 0;

}
//########################